
<h3>The Message Footer</h3>

<p>The message footer serves several purposes and is very important. When the message is forwarded to some other email address, the footer will be changed to be the one for "forwarded messages", which will allow
specifying different content for individuals who are not subscribed to your newsletters, to invite them to subscribe.</p>

<p>You can set the default footer in the
<?php

## for translators, you can translater the word "Configuration" below
echo PageLink2('configure&id=messagefooter', 'Configuration');
?>
 </p>

<p>You can use several placeholders, which will help your subscribers identify the email they receive and what to do with it.

<ul>
<li><b>[UNSUBSCRIBEURL]</b> - the personalised location for the subscriber to unsubscribe</li>
<li><b>[PREFERENCESURL]</b> - the personalised location for the subscriber to change their details</li>
<li><b>[FORWARDURL]</b> - the personalised location for the subscriber to forward the message to someone else</li>
<li><b>[EMAIL]</b> - the email address that received this message</li>
<li><b>[USERID]</b> - a unique string for this subscriber</li>
<li><b>[USERTRACK]</b> - the tracking code for "opens"</li>
</ul>
</p>

<h3>Suggested footer</h3>
<div class="suggestion">
<pre>
--
&lt;h2&gt;This message has been sent to [EMAIL] by <?php echo getConfig('message_from_name').' '.getConfig('admin_address')?>&lt;/h2&gt;

&lt;h3&gt;&lt;a href="[UNSUBSCRIBEURL]"&gt;Unsubscribe&lt;/a&gt;&lt;/h3&gt;
&lt;h3&gt;&lt;a href="[PREFERENCESURL]"&gt;Change preferences&lt;/a&gt;&lt;/h3&gt;
&lt;h3&gt;&lt;a href="[FORWARDURL]"&gt;Forward this message&lt;/a&gt;&lt;/h&gt;
[USERTRACK]
&lt;br/>Our Marketing dept | 1000 Marketing Road | Suite 16 | Market Town | ST | 00000
</pre>
</div>

<h3>Formatting</h3>
<p>You can use HTML in the footer. Try to keep it simple. The footer for the text version of emails will be generated from the HTML, by stripping HTML tags. If you do not use any HTML in the footer, the HTML version will be generated by adding &lt;br/&gt; for line endings.</p>


</p>
